#!/usr/bin/perl

use strict;
use warnings;
use utf8;

use Encode qw(decode_utf8);
use DBI;

binmode STDOUT, ':utf8';

my $dbh = DBI->connect('dbi:mysql:database=unicode_test;host=localhost', 'testuser', 'testuser')
            or die "Unable to connect: " . $DBI::errstr;

my $str = 'Mössbauer';

print "Str: $str\n";

if (utf8::is_utf8($str)) {
  print "String to insert is valid utf8\n";
} else {
    print "String to insert is NOT valid utf8\n";
}

my $insert_sth = $dbh->prepare('INSERT INTO unicode_test VALUES (?)');
$insert_sth->execute($str);

my $sth = $dbh->prepare(q(SELECT * FROM unicode_test));
$sth->execute;

while (my $row = $sth->fetchrow_arrayref) {
  my $res = decode_utf8($row->[0]);
  print "Result: $res\n";

  if (utf8::is_utf8($res)) {
    print "Result is valid utf8\n";
  } else {
    print "Result is NOT valid utf8\n";
  }
}

$sth->finish;
$dbh->disconnect;
